<?php
// $Id: papilia.form.inc,v 1.1.4.8 2009/06/08 04:56:18 lashad Exp $

/**
 * @file donation form functions
 *
 */
 
function papilia_delegate($url, $campaign) {

  global $_PAPILIA_ERRORS;
  global $language;

  $campaign_title = $campaign->title;

  //-- Multilinguality here
  $langcode = $language->language; //ISO2 code  
  $sql = 'SELECT n.nid FROM {node} n WHERE n.status = 1 and n.tnid = %d and n.language = \'%s\' ';
  $i18n_nid = db_result(db_query(db_rewrite_sql($sql), $campaign->nid, $langcode)); 
    
  if ( is_numeric($i18n_nid) && ($i18n_nid > 0)  ) {
    $node = node_load( $i18n_nid );
  }
  else {
    $node = node_load($campaign->nid);
  }

  drupal_set_title($node->title);
  
  $css = $node->field_pcss[0]['value'];
  $header = $node->body;
  $footer = $node->field_pfooter[0]['value'];    
  
  $mpath = drupal_get_path('module', 'papilia');
  require_once($mpath .'/papilia.countries.inc' );
  $form = drupal_get_form('papilia_donation_form', $campaign, $node);
  
  $out = '';
  $out = '<style>'. $css .'</style>';
  $out .= '<div class="papilia_form">';
  $out .= $header;
  
  $errors = $_PAPILIA_ERRORS;  
  unset( $_PAPILIA_ERRORS );
  
  $out .= theme_papilia_errors($errors);
  $out .= $form;
  $out .= $footer;  
  
  $out .= '</div>'; //end div[class]='papilia_form'
  return $out;
}

function theme_papilia_errors( $errors ) {
  if ( ! is_array($errors) || sizeof($errors) < 1 ) return "";
  
  $out = '<div class="message error"><ul>';
  foreach ( $errors['error'] as $err ) {
    $out .= '<li>'. $err .'</li>';
  }
  $out .= '</ul></div>';
  return $out;
}

function papilia_donation_form(&$form_state, $campaign, $campaign_node) {
  
  papilia_pre_submit_verification_resources($campaign->title);   
  
  $form['papilia_campaign_id'] = array(
    '#type' => 'hidden',
    '#value' => $campaign->nid,
  );
    
  $optional_fields = papilia_donor_fields ();  
  $currencies  = papilia_get_currencies(TRUE);
  $funds  = papilia_get_funds(TRUE);
  
  if (is_array($optional_fields) && sizeof($optional_fields) > 0 ) {
    $form['mainfields'] = array(
      '#type' => 'fieldset',
      '#title' => t('Personal Information'),
      '#collapsible' => TRUE,    
    );
  }

  if (is_array($optional_fields)) {
    foreach ($optional_fields as $field_key => $field_text) {
        if (!empty($campaign_node->donor_fields[$field_key])) {  
          $form['mainfields'][$field_key] = array(
            '#type' => 'textfield',
            '#title' => $field_text,    
            '#required' => TRUE,  
            '#maxlength' => papilia_donor_field_maxlength($field_key),  
          );        
        }    
    }
  }

  $form['mainfields']['EMAIL'] = array(
    '#type' => 'textfield',
    '#title' => t('Email'),        
    '#required' => TRUE,        
  );


  /*********** AMOUNT CHOICE **************/
  
  $form['money'] = array(
    '#type' => 'fieldset',
    '#title' => t('Donation Information'),
    '#collapsible' => TRUE,   
    '#tree' => TRUE, 
  );

  if (is_array($campaign_node->amt_choice) && sizeof($campaign_node->amt_choice) > 0) {
     $form['money']['preselected_amount'] = array(
      '#type' => 'select',
      '#title' => t('Choose a Pre-selected Amount'),        
      '#options' =>   array(),
    );

    $form['money']['preselected_amount']['#options']['-1'] = PAPILIA_SELECTION_NONE;
    
    foreach ($campaign_node->amt_choice as $amount) {
      $id = $amount['chvalue'] . '-' . $amount['chtype'];
      $pretty = $amount['chvalue'] . ' ' . $currencies[$amount['chtype']];
      $form['money']['preselected_amount']['#options'][$id] = $pretty;
    }
  }
  
  if ($campaign_node->free_entry_amount) { // if free-entry of amounts is allowed
  
    $form['money']['wrapper_prfx'] = array(
      '#value' => '<div class="float-contents clear clearfix">',
    );
    
    $form['money']['AMT'] = array(
      '#type' => 'textfield',
      '#title' => t('Specific Amount'), 
      '#maxlength' => 14, 
      '#size' => 14,
    );
  
    $form['money']['CURRENCY'] = array(
      '#type' => 'select',
      '#options' =>   $campaign_node->currency_selection['currency_selection_enabled'],
      '#default_value' => $campaign_node->default_cid,
    );
  
    $form['money']['wrapper_sfx'] = array(
      '#value' => '</div>',
    );
    
  }

  $funds = $campaign_node->funds_selection['funds_selection_enabled'];
  if (!empty($funds)) {
    $form['money']['DESCRIPTION'] = array(
      '#type' => 'select',
      '#title' => t('Choose fund allocation for your donation'),
      '#options' => $funds,
      '#default_value' => $campaign_node->default_fid,            
    );
  }
 
  $periods = $campaign_node->recurr_periods['recurr_periods_enabled'];
  if (!empty($periods)) {
    $form['money']['PAYPERIOD'] = array(
      '#type' => 'select',
      '#title' => t('Choose Recurring Period'),
      '#options' => $periods,
      '#default_value' => '-1',                  
    );
  }
 
  
  /*********** END AMOUNT CHOICE **************/  
    
  $form['billing'] = array(
    '#type' => 'fieldset',
    '#title' => t('Billing Information'),
    '#collapsible' => TRUE,    
  );
  
  $cards_img_path =  drupal_get_path('module', 'papilia') .'/img/weacceptcards.png';
  $form['billing']['weaccept'] = array(
    '#value' => theme_image($cards_img_path),
  );
  
  $form['billing']['TYPE'] = array(
    '#type' => 'select',
    '#title' => t('Credit Card Type'),
    '#options' => array( 
        'C/visa' => t("Visa"),
        'C/mastercard' => t("Mastercard"),
        'C/american' => t("American Express"),
        'C/discover' => t("Discover"),
        'C/jcb' => t("JCB"),
        'C/dinersclub' =>  t("Diner's Club"),        
    ),
  );

  $form['billing']['ACCT'] = array(
    '#type' => 'textfield',
    '#title' => t('Card Number'),
    '#description' => t('Please enter the card number with digits only, no dashes.'),
    '#required' => TRUE,
    '#maxlength' => 16, 
    '#size' => 16,
  );

  $form['billing']['NAME'] = array(
    '#type' => 'textfield',
    '#title' => t('Name on the card'),
    '#maxlength' => 128, 
    '#required' => TRUE,
  );

  $form['billing']['EXPDATE'] = array(
    '#type' => 'textfield',
    '#title' => t('Expiration Date'),
    '#required' => TRUE,
    '#size' => 4, 
    '#maxlength' => 4,
    '#description' => t('Four digits in MMYY format: two-digit month and two-digit year.'),
  );

  $form['billing']['CVV2'] = array(
    '#type' => 'textfield',
    '#title' => t('CVV2'),
    '#size' => 4, 
    '#maxlength' => 4,
    '#required' => TRUE,
    '#description' => t('Security code, usually located on the back of your card.'),
  );
  
  $form['billingaddr'] = array(
    '#type' => 'fieldset',
    '#title' => t('Billing Address'),
    '#collapsible' => TRUE,
  );

  $form['billingaddr']['STREET'] = array(
    '#type' => 'textfield',
    '#title' => t('Street'),
    '#maxlength' => 128, 
    '#required' => TRUE,
  );

  $form['billingaddr']['CITY'] = array(
    '#type' => 'textfield',
    '#title' => t('City'),
    '#maxlength' => 50, 
    '#required' => TRUE,
  );

  $states = array('none' => t('Outside the US'));
  $states = $states  + papilia_get_us_states();

  $form['billingaddr']['STATE'] = array(
    '#type' => 'select',
    '#title' => t('State'),
    '#options' => $states,
    '#required' => TRUE,
  );

  $form['billingaddr']['ZIP'] = array(
    '#type' => 'textfield',
    '#title' => t('Zip/Postal Code'),
    '#size' => 5, 
    '#maxlength' => 20,
    '#required' => TRUE,
  );


  $form['billingaddr']['COUNTRY'] = array(
    '#type' => 'select',
    '#title' => t('Country'),
    '#options' => papilia_get_countries(),
    '#required' => TRUE,
  );

  $form['papilia_dialog'] = array(
    '#value' => '<div id="papilia_dialog" class="papiliadialog"></div>',
  );
  
/*  $form['transact'] = array(
    '#value' => '<button id="donation_button">' . t('Send Payment') . '</button>',
  );**/
  
  $form['submit'] = array(
    '#prefix' => '<div class="papilia_submission">',
    '#type' => 'submit',
    '#value' => t('Send Payment'),
    '#suffix' => '</div>',
  );
  
  return $form;
}

function papilia_donation_form_validate($form, &$form_state) {
  global $_PAPILIA_ERRORS;
  
  
  $post = $form_state['values'];
    
  $funds = papilia_get_funds(TRUE);
  $currencies = papilia_get_currencies(TRUE);
    
  $found_problem = FALSE;
  
  /*************** VALIDATE MONEY SELECTION ***************/
  
  if ( (empty($post['money']['preselected_amount']) || 
       $post['money']['preselected_amount']<=0 ) &&
       (empty($post['money']['AMT']) ||
       $post['money']['AMT']<=0) ) {
       
       if (empty($post['money']['preselected_amount'])) { // no such form element
         form_set_error('money][AMT', t('You have to indicate donation amount.'));
         $found_problem = TRUE;
       }
       else {
         form_set_error('money][preselected_amount', t('You have to indicate donation amount.'));       
         $found_problem = TRUE;
       }
       
  }
  else {
    if (!empty($post['money']['preselected_amount']) && $post['money']['preselected_amount'] > 0 ) {
      $amount = $post['money']['preselected_amount'];
      $array = explode('-', $amount);
      $amount = trim($array[0]);
      $currency = $currencies[trim($array[1])];
    }
    else {
      $amount = $post['money']['AMT'];
      $currency = $post['money']['CURRENCY'];      
      $currency = $currencies[$currency]; //convert from index to name
    }
    
    $form_state['values']['AMT'] = $amount;
    $form_state['values']['CURRENCY'] = $currency;    
  }
  
  /*************** END VALIDATE MONEY SELECTION ***************/
  
  if (!empty($post['money']['FUND_ID'])) {
     $form_state['DESCRIPTION'] = $funds[$post['money']['FUND_ID']];
  }
  
  if ($post['COUNTRY'] == 'US' && $post['STATE'] == 'none') {
   $found_problem = TRUE;
   form_set_error('STATE', t('You have to indicate a state for US.'));
  }

  if ( !is_numeric($post['EXPDATE'])) {
   $found_problem = TRUE;
   form_set_error('EXPDATE', t('Expiration Date may not contain any non-numeric characters.'));
  }

  if ( strlen(trim($post['EXPDATE'])) != 4) {
   $found_problem = TRUE;
   form_set_error('EXPDATE', t('Expiration Date must be exactly four digits long.'));
  }

  if ( !is_numeric($post['CVV2'])) {
   $found_problem = TRUE;
   form_set_error('CVV2', t('CVV2 may not contain any non-numeric characters.'));
  }
 
  if ( ! $found_problem ) {
    $post = $form_state['values'];
    $campaign_node = $form['#parameters'][2];
    $post['campaign_node'] = $campaign_node;
    $post['campaign_node']->dfdbid = $form['#parameters'][3]->dfdbid;
    
    $test_mode = papilia_is_test_mode();
        
    $ret = papilia_call_wrapper($post, $test_mode); 
    $status = $ret->status;
  } 
  else { $status = TRUE; } //sudo status=TRUE since we don't even check it when zip code problem exists
  
  if ( ! $status ) {
    form_set_error('form_papilia_id', $ret->msg);
  }
  
  $errors = drupal_get_messages(null, TRUE);
  $_PAPILIA_ERRORS = $errors;  
    
  
}

function papilia_donation_form_submit($form, &$form_state) {

  unset($form_state['rebuild']);
  $form_state['redirect'] = 'papilia/thankyou';
  
  $msg =  t('Your donation has been successfully received. Thank you!');
  drupal_set_message( $msg, 'status' );

}

function papilia_generate_form_id($nid) {

  $res = db_fetch_object(db_query('SELECT nid, language, tnid from {node} WHERE status = 1 and nid = %d', $nid));
  
  if ( empty($res->language) ) { 
    $node_id = $res->nid; 
  } 
  else {
    $node_id = $res->tnid;
  }
  
  $node = node_load($node_id);
    
  $fid = $node->field_papilia_form_id[0]['value'];
  return $fid;
}

/**
* Process submitted data and make papilia API call.
*/
function papilia_call_wrapper( $post, $test_mode ) {
    
  $response = new stdClass();
 
  unset($post['op']); 
  unset($post['submit']);
  unset($post['form_build_id']); 
  unset($post['form_token']); 
  unset($post['form_id']);
  
  $email = $post['EMAIL'];
  
  $campaign_id = $post['papilia_campaign_id'];
  unset($post['form_papilia_id']);
  
  if ( $post['STATE'] == 'none' ) {
    unset($post['STATE']);
  }
  
  if ( strpos($post['AMT'], '.' ) === FALSE ) { 
    $post['AMT'] .= ".00";
  }
  
  $currencies = papilia_get_currencies(TRUE);
  $funds = papilia_get_funds(TRUE);
    
  $post['DESCRIPTION'] = $funds[$post['money']['DESCRIPTION']];  
  
  $payperiod = $post['money']['PAYPERIOD'];
  if (!empty($payperiod) && $payperiod != -1 ) {
    $post['PAYPERIOD'] = $payperiod;
  }
  
  unset($post['money']);
  
// This is deprecated. Editors enter dbfdid manually in the new version    
// $form_id = papilia_generate_form_id($post['papilia_campaign_id']);

  require_once( dirname(__FILE__) .'/papilia.client.inc');
  $ret = papilia_make_call( $post, $test_mode ); 
  
  if ( $ret->code > 199 && $ret->code < 300 ) {
    $call_resp = simplexml_load_string( $ret->data );  
    $prop = "papilia-gift"; //The dash in the property name creates problems unless in a separate var like this    
    
    $status = (string)$call_resp->$prop->status;
      
      
    //Check for a card denial.
    if ( !empty($status) && $status == 'failed' ) {
      $errmsg1 = (string)$call_resp->$prop->response; 
      $errmsg1 .= ' ' . t('Error reference # ') . (string)$call_resp->$prop->reference;
      $errmsg1 = "\n<p>". $errmsg1;
      $msg =  t('Payment did not go through. Your card was declined. Please double-check the information and try again.') . $errmsg1;
    } 
    else {
      $refnum = (string) $call_resp->$prop->reference; //->reference;
      $_SESSION["papilia_trx_refnum"] = $refnum; 
      $_SESSION["papilia_campaign_id"] = $campaign_id;       
      $response->status = 1;
            
      // Log successful transaction for security purposes (no CC info saved).
      $currencies = papilia_get_currencies(TRUE);
      $tx_rec = new stdClass();
      $tx_rec->tx_refnum = $refnum;
      $tx_rec->nid = $post['campaign_node']->nid;
      $tx_rec->vid = $post['campaign_node']->vid;      
      $tx_rec->amount = $post['AMT'];
      $tx_rec->currency = $post['CURRENCY'];
      $name = $post['FIRSTNAME'] .' '. $post['MIDDLENAME'] .' '. $post['LASTNAME'];
      $tx_rec->donor_name  = $name;
      $tx_rec->donor_email = $post['EMAIL'];
      $tx_rec->processed = time();
            
      drupal_write_record('papilia_transaction', $tx_rec);                      
      return $response;
    }           
    
  }
  else {    
    $msg =  t('An error occured during papilia transaction: ') . $ret->error; 
    $watchdog_variables = array(
       '%code'  => $ret->code,
       '%error' => $ret->error,
       '%data'  => $ret->data,
    );      
    watchdog('papilia', "Error (%code): %error<br /><pre>%data</pre>", $watchdog_variables, WATCHDOG_ERROR);
  }
  
  //succes returns immediately above,so if you get here, it's an error.
  $response->status = 0;
  $response->msg = $msg;
  return $response;

}

function papilia_load( $nid ) {
  return node_load($nid);
}

function papilia_thankyou( $confirmation='invalid request' ) {

  $refnum = $_SESSION['papilia_trx_refnum'];
  unset($_SESSION['papilia_trx_refnum']);
  
  $campaign_id = $_SESSION['papilia_campaign_id'];
  unset($_SESSION['papilia_campaign_id']);  

    
  if (empty($refnum) || empty($campaign_id)) {
    $msg = t("Invalid Request!");
    drupal_set_title( $msg );
    return t('You are not supposed to access this page directly');
  }

  // Default Message:
  $msg = t("Confirmation Number:") ." ". $refnum ."<br/>" .
         t("Please write it down for your records") ;
         
  // Customized per campaign from campaign edit form:    
  $campaign_node = node_load( $campaign_id);
  if (is_object($campaign_node)) {
    $thankyou = $campaign_node->thankyou_template;
    if (!empty($thankyou)) {
      $thankyou = str_replace('%confirmation', $refnum, $thankyou);
      $thankyou = str_replace('%campaign', $campaign_node->title, $thankyou);
      $msg = check_markup($thankyou, FILTER_HTML_ESCAPE, FALSE);
    }
  }

         
  return $msg;         
}

