Drupal.behaviors.papilia_donation_submitter = function(context) {    

  $(".papilia_submission input", context).click(function(e) {
       e.preventDefault();
              
       var check = papilia_modaltext_display();
       
       if (check == -100) {
         return false;
       }
        
       papilia_showmodal();

       if ( ! $("#papilia_dialog").dialog( "isOpen" ) ) {
         $("#papilia_dialog").dialog("open");
       }
        
       return false;
   });

}

function papilia_showmodal() {

  var btn_proceed = Drupal.t('Yes, proceed');
  var btn_cancel = Drupal.t('No, cancel');
    
  buttons = {};
  buttons[btn_proceed] = function() {
    $('.ui-dialog-buttonpane').hide();        
    $('#papilia-donation-form').get(0).submit();
  }

  buttons[btn_cancel] = function() { 
    $(this).dialog("close"); 
  }

  $("#papilia_dialog").dialog({ 
      modal: true,
      overlay: { 
        opacity: 0.8, 
        background: "black" 
      },
      buttons: buttons
  });

}

function papilia_modaltext_display() {
  
  var params = { 
    "%campaign_title": Drupal.settings.papilia.campaign_title
  }; 

  var donation_amount = papilia_determine_amount();
  
  if (donation_amount == -100) {
    alert ( Drupal.t('Please select an appropriate amount'));
    return -100;
  }
  
  var pp_msg = "<span class=\"ppmsg\">";
  pp_msg += Drupal.t('You are about to donate');
  pp_msg += " <div class=\"ppamount\">" + donation_amount +  "</div> ";
  pp_msg += Drupal.t('to the &laquo; %campaign_title &raquo; campaign.', params);
  pp_msg += '<p>' + Drupal.t('Do you want to proceed?');   
  pp_msg += "</span>";  
  
  $("div#papilia_dialog").html(pp_msg);
}

function papilia_determine_amount() {
  var wdgt_specific = $("#edit-money-AMT");
  if (wdgt_specific.length==1) {
    var num = wdgt_specific.val();
      var wdgt_curr = $("#edit-money-CURRENCY");
      if (wdgt_curr.length == 1) {
        var dom_curr = wdgt_curr.get(0);
        if (dom_curr.selectedIndex>-1) {
          var currency = dom_curr.options[dom_curr.selectedIndex].text;
          if (num>0) {
            return num + ' ' + currency;
          }
        }
      }
  }
  
  // If specific amount did not match, proceed with preselected.
  
  var wdgt_psa = $("#edit-money-preselected-amount");
  if (wdgt_psa.length == 1) {
    var dom_psa = wdgt_psa.get(0);
    if (dom_psa.selectedIndex < 1) {
      return -100;
    }
    var caption = dom_psa.options[dom_psa.selectedIndex].text;
    return caption;
  }
  
  return -100; //Default is: could not detrmine appropriate amount/currency
}