<?php
// $Id: papilia.util.inc,v 1.1.4.7 2009/06/08 02:11:40 lashad Exp $

/**
 * @file Utility Functions for Papilia
 *
 */

function papilia_save_campaign(&$node) {

  $campaign = new stdClass();
  $campaign->dfdbid = $node->dfdbid;
  $campaign->uri = $node->uri;  
  $campaign->nid = $node->nid;
  $campaign->vid = $node->vid;
  $campaign->default_fid = $node->default_fund;
  $campaign->default_cid = $node->default_currency;
  $campaign->donor_fields = serialize($node->donor_fields);
  $campaign->recurr_periods = serialize($node->recurr_periods);  
  $campaign->thankyou_template = $node->thankyou_template;
    
    if (is_array($node->amt_choice)) {
      foreach ($node->amt_choice as $key => $val) {
        if (empty($val['chvalue'])) {
          unset($node->amt_choice[$key]);
        }
      }
    }
    $amounts = new stdClass();
    $amounts->free_entry_amount = $node->free_entry_amount;
    $amounts->amt_choice = $node->amt_choice;
    $campaign->amounts = serialize($amounts);

  // There's no way to know if record already exists, so we always run an Insert.
  db_query ( "DELETE from {" . PAPILIA_CAMPAIGN_NODE_TYPE . "} WHERE nid=%d", $node->nid);
  drupal_write_record(PAPILIA_CAMPAIGN_NODE_TYPE, $campaign);
  
  $selected_funds = $node->funds_selection['funds_selection_enabled'];
  db_query ( "DELETE from {papilia_campaigns_x_funds} WHERE nid=%d", $node->nid);  
  if (is_array($selected_funds)) {
    $i=0;
    foreach ($selected_funds as $fundid) {
      $fund = new stdClass();
      $fund->fid = $fundid;
      $fund->nid = $campaign->nid;
      $fund->vid = $campaign->vid;
      $fund->weight = $i++;      
      drupal_write_record('papilia_campaigns_x_funds', $fund);            
    }
  }

  $selected_currencies = $node->currency_selection['currency_selection_enabled'];
  db_query ( "DELETE from {papilia_campaigns_x_currencies} WHERE nid=%d", $node->nid);  
  if (is_array($selected_currencies)) {
    $i=0;
    foreach ($selected_currencies as $crid) {
      $curr = new stdClass();
      $curr->crid = $crid;
      $curr->nid = $campaign->nid;
      $curr->vid = $campaign->vid;
      $curr->weight = $i++;
      drupal_write_record('papilia_campaigns_x_currencies', $curr);            
    }
  }
  
  module_invoke('menu', 'rebuild');
}

function papilia_load_campaign(&$node) {

  $result = db_query("SELECT * from {" . PAPILIA_CAMPAIGN_NODE_TYPE . "} WHERE nid=%d AND vid=%d", $node->nid, $node->vid);
  while ($obj = db_fetch_object($result)) {
    $node->dfdbid = $obj->dfdbid;
    $node->uri = $obj->uri;
    $node->thankyou_template = $obj->thankyou_template;
    $node->default_fid = $obj->default_fid;
    $node->default_cid = $obj->default_cid;
    $node->donor_fields = unserialize($obj->donor_fields);    
        $amounts = unserialize($obj->amounts);
        $node->free_entry_amount = $amounts->free_entry_amount;
        $node->amt_choice = $amounts->amt_choice;
    $node->recurr_periods = unserialize($obj->recurr_periods);  
  }

  $node->recurr_periods = papilia_period_get_names($node->recurr_periods);
  
  $result = db_query("SELECT fid as papid from {papilia_campaigns_x_funds} WHERE nid=%d and vid=%d", $node->nid, $node->vid);
  $enabled_fund_ids = _papilia_db_get_ids_list($result);
  $result = db_query("SELECT crid as papid from {papilia_campaigns_x_currencies} WHERE nid=%d and vid=%d", $node->nid, $node->vid);
  $enabled_currency_ids = _papilia_db_get_ids_list($result);
    
  $res = db_query("SELECT n.nid, n.title 
                   FROM {node} n
                   INNER JOIN {papilia_campaigns_x_funds} x ON x.fid=n.nid
                   WHERE n.nid IN ($enabled_fund_ids) and n.type='%s'
                   ORDER BY x.weight ASC", PAPILIA_FUND_NODE_TYPE);
  $node->funds_selection['funds_selection_enabled'] = papilia_db_get_assoc_options($res);
  $res = db_query("SELECT nid, title FROM {node} WHERE nid NOT IN ($enabled_fund_ids) and type='%s' ORDER BY title asc", PAPILIA_FUND_NODE_TYPE);
  $node->funds_selection['funds_selection_disabled'] = papilia_db_get_assoc_options($res);

  $res = db_query("SELECT n.nid, n.title 
                   FROM {node} n 
                   INNER JOIN {papilia_campaigns_x_currencies} x ON x.crid=n.nid                   
                   WHERE n.nid IN ($enabled_currency_ids) and type='%s'
                   ORDER BY x.weight ASC", PAPILIA_CURRENCY_NODE_TYPE);
  $node->currency_selection['currency_selection_enabled'] = papilia_db_get_assoc_options($res);
  $res = db_query("SELECT nid, title FROM {node} WHERE nid NOT IN ($enabled_currency_ids) and type='%s' ORDER BY title asc", PAPILIA_CURRENCY_NODE_TYPE);
  $node->currency_selection['currency_selection_disabled'] = papilia_db_get_assoc_options($res);
  
}

function papilia_period_get_names($node_periods) {

  $sections = array('recurr_periods_disabled', 'recurr_periods_enabled');
  $periods = papilia_get_recurr_periods();
  foreach ($sections as $sec) {
    $tmp_array = $node_periods[$sec];
    if (is_array($tmp_array) && sizeof($tmp_array)>0) {  
      foreach ($tmp_array as $key => $val) {
        $node_periods[$sec][$key] = $periods[$key];
      }
    }
  }
  
  return $node_periods;
  
}

/** 
*
* Get all currencies 
*
*/
function papilia_get_currencies($as_fapi_options=FALSE) {
  $sql = "SELECT nid, vid, title from {node} WHERE type = '%s' AND status=1";
  $ret = db_query($sql, PAPILIA_CURRENCY_NODE_TYPE);
  $currencies = array();
  while ($obj = db_fetch_object($ret)) {
   if ($as_fapi_options) {
     $currencies[$obj->nid] = $obj->title;
   }
   else {
     $currencies[$obj->nid] = $obj;
   }
   
  }
  
  return $currencies;
}

/**
* Get all funds
*/
function papilia_get_funds($as_fapi_options=FALSE) {
  $sql = "SELECT nid, vid, title from {node} WHERE type = '%s' AND status=1";
  $ret = db_query($sql, PAPILIA_FUND_NODE_TYPE);
  $funds = array();
  while ($obj = db_fetch_object($ret)) {
    if ($as_fapi_options) {
       $funds[$obj->nid] = $obj->title;
     }
     else {
       $funds[$obj->nid] = $obj;
     }     
  }

  return $funds;
}

function papilia_get_recurr_periods() {
  return array (  
    '-1'   => t('One-time payment'),
    'DAIL' => t('Daily'), 
    'WEEK' => t('Weekly'), 
    'BIWK' => t('Every 2 weeks'),
    'SMMO' => t('Twice a month'), 
    'MONT' => t('Each month'), 
    'BIMO' => t('Every 2 months'), 
    'QTER' => t('Every 3 months'), 
    'SMYR' => t('Twice a year'),
    'YEAR' => t('Yearly'),  
  );
}


/**
*  Get a resultset of some query, pick-out "papid" fields (made-up unique name) and get a comma-sep string.
*
*  Just a little, stupid function helping avoid code duplication
*/
function _papilia_db_get_ids_list($result) {
  
  $ids = array();
  while ($row = db_fetch_object($result)) {
    $ids[] = $row->papid;
  }
  
  $ret = "-1"; //avoid burfing on empty list. No id should ever be "-1"
  if (sizeof($ids)>0) {
    $ret = implode(",", $ids);
  }
  
  return $ret;
}

/**
*  Get a resultset of some query, pick-out "nid and title" fields (aliases) and create an assoc array
*/
function papilia_db_get_assoc_options($result) {  
  $options = array();
  while ($row = db_fetch_object($result)) {
    $options[$row->nid] = $row->title;
  }
    
  return $options;
}


/******** OLD CODE *************/

function papilia_block($op = 'list', $delta = 0, $edit = array()) { 
  global $language;
  
  if ( $op == "list" || $op == "view" ) {
    $blocks = array();
    $lang = language_default();
    $langcode = $lang->language;
    $sql = "SELECT node.nid, node.title
                FROM {node} node   
                WHERE node.status = 1 AND (node.type ='%s') AND language='%s'";
    $res = db_query($sql, PAPILIA_CAMPAIGN_NODE_TYPE, $langcode );
  }
  
  if ($op == "list") {
    
    while ($obj =  db_fetch_object($res)) {      
      $blockid = 'papilia-'. $obj->nid;
      $blocks[$blockid] = array(
      'info' => t('Papilia: '. $obj->title),
      'cache' => BLOCK_NO_CACHE,
      );
    }
    
    return $blocks; 
  }
  else if ($op == 'view') {
    while ($obj =  db_fetch_object($res)) { 
      $blockid = 'papilia-'. $obj->nid;     
      if ($delta == $blockid) {
        $campaign = get_campaign_node($obj->nid, FALSE); //do not change page title 
        papilia_pre_submit_verification_resources($campaign->title);   
        $block = array(
          'content' => check_markup($campaign->body, FILTER_HTML_ESCAPE),
        );
      }
    return $block;
    }
  }
}

function get_campaign_node($nid, $change_title = TRUE) {
  global $language;
       
  if ( ! $change_title )  {
   $oldtitle = drupal_get_title();
  }   
  
  $langcode = $language->language; //ISO2 code  
  $i18n_nid == NULL;       
  $sql = 'SELECT n.nid FROM {node} n WHERE n.status = 1 and n.tnid = %d and n.language = \'%s\' ';
  $i18n_nid = db_result(db_query(db_rewrite_sql($sql), $nid, $langcode)); 
  
  if ( !is_numeric($i18n_nid) || !($i18n_nid > 0)  ) { 
    $i18n_nid = $nid;
  }
  $node = node_load($i18n_nid);
  $url = get_papilia_url_prefix() ."/". $node->field_puri[0]['value'];
  $campaign = new stdClass();
  $campaign->nid = $node->nid;
  $campaign->title = check_plain($node->title);      
  $campaign->status = $node->status;
  $campaign->url = $node->field_puri[0]['value'];
  $content = "<style>span.submitted {display: none}</style>";
  $content .= papilia_delegate($url, $campaign);
  
  $ret = new stdClass();
  $ret->title = check_plain($node->title);
  $ret->nid = $i18n_nid;
  $ret->body = check_markup($content, FILTER_HTML_ESCAPE);
  
  if ( ! $change_title )  {
   drupal_set_title($oldtitle);
  }   

  return $ret;
  
}
 
 
 
 
 
 
 
/**
* A wrapper around papilia_get_vocabularies() adding the "use global" option.
*/
function papilia_fund_vocabularies() {
  $funds = papilia_get_vocabularies();
  $mfunds= array('global' => '- '. t('Use Global Setting') .' - ' ) ;
  if ( is_array($funds) && sizeof($funds) > 0 ) {
    foreach ($funds as $key => $val ) {
      $mfunds[$key] = $val;
    }
  }
  else { //no vocabularies exist, global setting is bunk as well
    return array();
  }
  
  return $mfunds;
}

function papilia_get_funds_depr(&$campaign_node) {

  $vid = $campaign_node->field_fund_vocabulary[0]['value'];
    
  if (empty($vid)) return FALSE; //do not display fund allocation
  
  if ($vid == 'global') { //use default setting
    $vid = get_papilia_donation_fund();
  }

  $terms = taxonomy_get_tree($vid);

  $terms_options = array('---' => t('No specific fund allocation')); //reformat
  if ( !is_array($terms) || sizeof($terms)<1 ) return $terms_options;
  foreach ($terms as $t) {
    $terms_options[$t->name] = t($t->name);
  }
  return $terms_options;
}

function papilia_get_vocabularies() {
  $sql = "SELECT vid, name FROM {vocabulary}";
  $res = db_query($sql);
  $vocabs = array();
  while ( $obj = db_fetch_object($res) ) {
    $vocabs[$obj->vid] = $obj->name;
  }
  return $vocabs;
}

function get_papilia_mangled_id() {
  return variable_get('papilia_mangled_id', 'FXss');
}

function get_papilia_api_signature() {
  return variable_get('papilia_api_signature', 'XXXXXXXXXXXXXXX');
}

function get_papilia_donation_fund() {
  return variable_get('papilia_donation_fund', '');
}

function papilia_is_test_mode() {
  $ret = variable_get('papilia_test_mode', '1') ? 'true' : 'false';
  return $ret;
}
